<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Parse server example</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/parse/2.11.0/parse.min.js"
            integrity="sha256-Wgdjb0F7RJTdnkYA/y6Y5R/e1QllNlBN3Qs0hP8Ev7Q=" crossorigin="anonymous"></script>
    <script
            src="https://code.jquery.com/jquery-3.4.1.min.js"
            integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
            crossorigin="anonymous"></script>
    <style>
        .post_image {
            width: 200px;
            height: 200px;
        }
    </style>
</head>
<body>
<h1>Parse server example</h1>


<input id="post_text" placeholder="post text"/><br/>
<input id="author" placeholder="author"/><br/>
photo: <input type="file" id="profilePhotoFileUpload"><br/>

<button id="savePost">Save Post</button>

<div id="posts"></div>
<script>

    //kiryat malakhi coordinates = 31.729737, 34.751827
    var kiryatMalakhi = new Parse.GeoPoint({latitude: 31.729737, longitude: 34.751827});
    var jerusalem = new Parse.GeoPoint({latitude: 31.760247, longitude: 35.219711});

    const distance = 5;
    const sorted = true;


    const ngrokUrl = "http://localhost:1337";
    Parse.initialize("myAppId");
    Parse.serverURL = ngrokUrl + '/parse';
    const Post = Parse.Object.extend("Post");

    async function saveObject(obj) {
        const save = await obj.save();
        console.log(save);
    }

    $("#savePost").on('click', () => {
        savePost();
    });

    function saveParseObject(post) {
        post.save()
            .then((pst) => {
                // Execute any logic that should take place after the object is saved.
                $("#post_text").val("");
                $("#author").val("");
                $("#savePost").text("Save Post")
            }, (error) => {
                // Execute any logic that should take place if the save fails.
                // error is a Parse.Error with an error code and message.
                alert('Failed to create new object, with error code: ' + error.message);
            });
    }

    function savePost() {
        if (!$("#post_text").val() || !$("#author").val()) {
            return
        }
        $("#savePost").text("please wait...");
        // Create a new instance of that class.
        const post = new Post();
        post.set("text", $("#post_text").val());
        post.set("author", $("#author").val());
        post.set("location", kiryatMalakhi);

        var fileUploadControl = $("#profilePhotoFileUpload")[0];
        if (fileUploadControl.files.length > 0) {
            var file = fileUploadControl.files[0];
            var name = "photo.jpg";
            var parseFile = new Parse.File(name, file);
            parseFile.save().then(function () {
                // The file has been saved to Parse.
                post.set("photo", parseFile);
                saveParseObject(post);
            }, function (error) {
                alert("save photo failed")
            });
        } else {
            saveParseObject(post);
        }
    }


    let posts = [];
    const post = new Parse.Query(Post);
    // post.withinKilometers("location", kiryatMalakhi, distance, sorted);
    post.find()
        .then((results) => {
            if (results) {
                posts = results;
                renderPosts()
            }
        })
        .catch();

    let query = new Parse.Query('Post');
    // query.withinKilometers("location", kiryatMalakhi, distance, sorted);

    function addNewPost(object) {
        var query = new Parse.Query(Post);
        query.get(object.id)
            .then((pst) => {
                posts.push(pst);
                renderPosts();
            }, (error) => {
                // The object was not retrieved successfully.
                // error is a Parse.Error with an error code and message.
            });
    }

    query.subscribe()
        .then(subscription => {
            console.log('subscription: ', subscription);
            subscription.on('open', () => {
                console.log('subscription opened');
            });
            subscription.on('create', (object) => {
                console.log('post object created', object);
                addNewPost(object);
            });

            subscription.on('enter', (object) => {
                addNewPost(object);
            });

            subscription.on('leave', (object) => {
                console.log('object left');
                posts = posts.filter(pst => pst.id !== object.id);
                renderPosts();
            });

            subscription.on('update', (object) => {
                console.log('post object updated', object);
                const index = posts.findIndex(pst => pst.id === object.id);
                posts[index] = object;
                renderPosts()
            });

            subscription.on('delete', (object) => {
                console.log('post object deleted', object);
                posts = posts.filter(pst => pst.id !== object.id);
                renderPosts();
            });
        }).catch(err => {
        console.log('err', err);
    });

    function renderPosts() {
        $("#posts").empty();
        for (let i = 0; i < posts.length; i++) {
            var object = posts[i];
            const text = object.get("text");
            const author = object.get("author");
            let postImage = "https://www.selltrade.co.za/wp-content/uploads/2019/12/placeholder.png";
            if (object.get("photo")) {
                console.log(object.get("photo").name());
                postImage = object.get("photo").url()
                console.log(postImage);
            }
            $("#posts").append("<div><div>" + author + ", " + text + "</div><div><img class='post_image' src='" + postImage + "'/></div></div>")
        }
    }

</script>
</body>
</html>
